"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var roles_1 = require("../roles");
describe('downgradeRoleToNonSigner', function () {
    it.each(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        role                 | expected\n        ", "        | ", "\n        ", "        | ", "\n        ", " | ", "\n        ", " | ", "\n    "], ["\n        role                 | expected\n        ", "        | ", "\n        ", "        | ", "\n        ", " | ", "\n        ", " | ", "\n    "])), 'READONLY', 'READONLY', 'WRITABLE', 'WRITABLE', 'READONLY_SIGNER', 'READONLY', 'WRITABLE_SIGNER', 'WRITABLE')('downgrades $role to $expected', function (_a) {
        var role = _a.role, expected = _a.expected;
        expect((0, roles_1.downgradeRoleToNonSigner)(roles_1.AccountRole[role])).toBe(roles_1.AccountRole[expected]);
    });
});
describe('downgradeRoleToReadonly', function () {
    it.each(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n        role                 | expected\n        ", "        | ", "\n        ", "        | ", "\n        ", " | ", "\n        ", " | ", "\n    "], ["\n        role                 | expected\n        ", "        | ", "\n        ", "        | ", "\n        ", " | ", "\n        ", " | ", "\n    "])), 'READONLY', 'READONLY', 'WRITABLE', 'READONLY', 'READONLY_SIGNER', 'READONLY_SIGNER', 'WRITABLE_SIGNER', 'READONLY_SIGNER')('downgrades $role to $expected', function (_a) {
        var role = _a.role, expected = _a.expected;
        expect((0, roles_1.downgradeRoleToReadonly)(roles_1.AccountRole[role])).toBe(roles_1.AccountRole[expected]);
    });
});
describe('isSignerRole', function () {
    it.each([roles_1.AccountRole.READONLY, roles_1.AccountRole.WRITABLE])('returns `false` for AccountRole.$role', function (role) {
        expect((0, roles_1.isSignerRole)(role)).toBe(false);
    });
    it.each([roles_1.AccountRole.READONLY_SIGNER, roles_1.AccountRole.WRITABLE_SIGNER])('returns `true` for AccountRole.$role', function (role) {
        expect((0, roles_1.isSignerRole)(role)).toBe(true);
    });
});
describe('isWritableRole', function () {
    it.each([roles_1.AccountRole.READONLY, roles_1.AccountRole.READONLY_SIGNER])('returns `false` for AccountRole.$role', function (role) {
        expect((0, roles_1.isWritableRole)(role)).toBe(false);
    });
    it.each([roles_1.AccountRole.WRITABLE, roles_1.AccountRole.WRITABLE_SIGNER])('returns `true` for AccountRole.$role', function (role) {
        expect((0, roles_1.isWritableRole)(role)).toBe(true);
    });
});
describe('mergeRoles', function () {
    it.each(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n        aRole                | bRole                | expected\n        ", "        | ", "        | ", "\n        ", "        | ", "        | ", "\n        ", "        | ", " | ", "\n        ", "        | ", " | ", "\n        ", "        | ", "        | ", "\n        ", "        | ", "        | ", "\n        ", "        | ", " | ", "\n        ", "        | ", " | ", "\n        ", " | ", "        | ", "\n        ", " | ", "        | ", "\n        ", " | ", " | ", "\n        ", " | ", " | ", "\n        ", " | ", "        | ", "\n        ", " | ", "        | ", "\n        ", " | ", " | ", "\n        ", " | ", " | ", "\n    "], ["\n        aRole                | bRole                | expected\n        ", "        | ", "        | ", "\n        ", "        | ", "        | ", "\n        ", "        | ", " | ", "\n        ", "        | ", " | ", "\n        ", "        | ", "        | ", "\n        ", "        | ", "        | ", "\n        ", "        | ", " | ", "\n        ", "        | ", " | ", "\n        ", " | ", "        | ", "\n        ", " | ", "        | ", "\n        ", " | ", " | ", "\n        ", " | ", " | ", "\n        ", " | ", "        | ", "\n        ", " | ", "        | ", "\n        ", " | ", " | ", "\n        ", " | ", " | ", "\n    "])), 'READONLY', 'READONLY', 'READONLY', 'READONLY', 'WRITABLE', 'WRITABLE', 'READONLY', 'READONLY_SIGNER', 'READONLY_SIGNER', 'READONLY', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE', 'READONLY', 'WRITABLE', 'WRITABLE', 'WRITABLE', 'WRITABLE', 'WRITABLE', 'READONLY_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER', 'READONLY_SIGNER', 'READONLY', 'READONLY_SIGNER', 'READONLY_SIGNER', 'WRITABLE', 'WRITABLE_SIGNER', 'READONLY_SIGNER', 'READONLY_SIGNER', 'READONLY_SIGNER', 'READONLY_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER', 'READONLY', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER', 'READONLY_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER')('returns $expected when given $aRole and $bRole', function (_a) {
        var aRole = _a.aRole, bRole = _a.bRole, expected = _a.expected;
        expect((0, roles_1.mergeRoles)(roles_1.AccountRole[aRole], roles_1.AccountRole[bRole])).toBe(roles_1.AccountRole[expected]);
    });
});
describe('upgradeRoleToSigner', function () {
    it.each(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n        role                 | expected\n        ", "        | ", "\n        ", "        | ", "\n        ", " | ", "\n        ", " | ", "\n    "], ["\n        role                 | expected\n        ", "        | ", "\n        ", "        | ", "\n        ", " | ", "\n        ", " | ", "\n    "])), 'READONLY', 'READONLY_SIGNER', 'WRITABLE', 'WRITABLE_SIGNER', 'READONLY_SIGNER', 'READONLY_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER')('upgrades $role to $expected', function (_a) {
        var role = _a.role, expected = _a.expected;
        expect((0, roles_1.upgradeRoleToSigner)(roles_1.AccountRole[role])).toBe(roles_1.AccountRole[expected]);
    });
});
describe('upgradeRoleToWritable', function () {
    it.each(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n        role                 | expected\n        ", "        | ", "\n        ", "        | ", "\n        ", " | ", "\n        ", " | ", "\n    "], ["\n        role                 | expected\n        ", "        | ", "\n        ", "        | ", "\n        ", " | ", "\n        ", " | ", "\n    "])), 'READONLY', 'WRITABLE', 'WRITABLE', 'WRITABLE', 'READONLY_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER', 'WRITABLE_SIGNER')('upgrades $role to $expected', function (_a) {
        var role = _a.role, expected = _a.expected;
        expect((0, roles_1.upgradeRoleToWritable)(roles_1.AccountRole[role])).toBe(roles_1.AccountRole[expected]);
    });
});
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
