"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isInstructionForProgram = isInstructionForProgram;
exports.assertIsInstructionForProgram = assertIsInstructionForProgram;
exports.isInstructionWithAccounts = isInstructionWithAccounts;
exports.assertIsInstructionWithAccounts = assertIsInstructionWithAccounts;
exports.isInstructionWithData = isInstructionWithData;
exports.assertIsInstructionWithData = assertIsInstructionWithData;
var errors_1 = require("@solana/errors");
function isInstructionForProgram(instruction, programAddress) {
    return instruction.programAddress === programAddress;
}
function assertIsInstructionForProgram(instruction, programAddress) {
    if (instruction.programAddress !== programAddress) {
        throw new errors_1.SolanaError(errors_1.SOLANA_ERROR__INSTRUCTION__PROGRAM_ID_MISMATCH, {
            actualProgramAddress: instruction.programAddress,
            expectedProgramAddress: programAddress,
        });
    }
}
function isInstructionWithAccounts(instruction) {
    return instruction.accounts !== undefined;
}
function assertIsInstructionWithAccounts(instruction) {
    if (instruction.accounts === undefined) {
        throw new errors_1.SolanaError(errors_1.SOLANA_ERROR__INSTRUCTION__EXPECTED_TO_HAVE_ACCOUNTS, {
            data: instruction.data,
            programAddress: instruction.programAddress,
        });
    }
}
function isInstructionWithData(instruction) {
    return instruction.data !== undefined;
}
function assertIsInstructionWithData(instruction) {
    var _a;
    if (instruction.data === undefined) {
        throw new errors_1.SolanaError(errors_1.SOLANA_ERROR__INSTRUCTION__EXPECTED_TO_HAVE_DATA, {
            accountAddresses: (_a = instruction.accounts) === null || _a === void 0 ? void 0 : _a.map(function (a) { return a.address; }),
            programAddress: instruction.programAddress,
        });
    }
}
